// test TC74 sur picdem2+
// C.D 02/2003

#include <p18f452.h>
#include "initxlcd.c"

#define adrtc74 0b1001101
#define regtemp 0
#define config 1

signed char temp;			// variable temprature
unsigned char tampon[3];		// mmoire pour les chaines converties avec BTOA 

void ack(void)					// attend acknowledge (I2C) de l'esclave
{
while(SSPSTATbits.R_W);			// attend fin de transmission
while (SSPCON2bits.ACKSTAT);	// attend fin ACK esclave
}

signed char lit_i2c(unsigned char adresse, unsigned char registre) //retourne le contenu du registre cmd dans TC74
{
signed char t;
 SSPCON2bits.SEN=1;			// START
 while (SSPCON2bits.SEN);
 SSPBUF=adresse<<1; 		// adresse ecriture 
 ack();				
 SSPBUF=registre;				// adresse registre
 ack();
 SSPCON2bits.RSEN=1; 		// RESTART
 while (SSPCON2bits.RSEN);
 SSPBUF=(adresse<<1)|0b00000001; 		// adresse lecture 
 ack();
 SSPCON2bits.RCEN=1; 		// passe ne mode lecture d'un octet
 while (SSPCON2bits.RCEN);  // attend reception termine
 t=SSPBUF;					// mmorise temprature
 SSPCON2bits.ACKDT=1;		// NON-ACK
 SSPCON2bits.ACKEN=1; 
 while(SSPCON2bits.ACKEN);
 SSPCON2bits.PEN=1;			// STOP
 while(SSPCON2bits.PEN);
 return (t); 
}

void init_i2c(void)
{
	DDRCbits.RC3 = 1;         	// SCL (PORTC,3) en entre
 	DDRCbits.RC4 = 1;         	// SDA (PORTC,4) en entre
 	SSPCON1=0b00101000;		// WCOL SSPOV SSPEN CKP SSPM3:SSPM0
 							// efface WCOL et SSPOV, active I2C, I2C mode maitre horloge=FOSC/(4*(SSPADD+1))			
 	SSPSTATbits.SMP=1;			// slew rate inhib (f<400Khz)
 	SSPADD=5;					// horloge = 4Mhz / 24 = 166,66 KHz
}

void main(void)
{
 OpenXLCD(FOUR_BIT & LINES_5X7 );

 init_i2c();
 
while (1)
	{
	while(!(lit_i2c(adrtc74,config)&0b01000000));	// attend mesure ok (Bit D6 (du registre CONFIG TC74) =1)
	temp=lit_i2c(adrtc74,regtemp);			// le rsultat est direct (cod signed char), voir doc TC74
	
    SetDDRamAddr(0);
    putsXLCD(btoa(temp,tampon));	// crit un byte  (8 bits)
    putchar('c');
	}
}
