#pragma chip PIC12F675


const unsigned char sortie[]={0b00010000,0b00100000,0b00010000,0b00000100,0b00100000,0b00000100,0b00000100,0b00000010};
const unsigned char sens[]={0b11001111,0b11001111,0b11101011,0b11101011,0b11011011,0b11011011,0b11111001,0b11111001};

#pragma interruptSaveCheck n // pas de test d'IT, les registres W et PCLATCH ne sont pas sauvegards.
#pragma origin 4			// adresse d'IT sur PIC12

interrupt ITtimer0(void)	// SP de traitement de l'IT TIMER0
{
static unsigned char i,cptIT;	// i pointe les LED, cptIT compteur d'interruptions
//int_save_registers
if (++cptIT>=10)
	{
		TRISIO=sens[i];
		GPIO=sortie[i];	
		i++;
		if (i>=8) i=0;
		cptIT=0;
	}
	T0IF=0;
//int_restore_registers // W, STATUS et PCLATH)
}

void main(void)
{
	GPIO=0;			// pour init GPIO
	CMCON=7;		// finction comparateur desactivee
	ANSEL=0;		// AN0 - AN3 entrees numeriques
	T0CS=0;			// horloge interne sur TIMER0 (dans OPTION)
	PSA=0;			// prdiviseur sur TIMER0 (dans OPTION)
					// prdiviseur par 128 lors du reset
	T0IE=1;			// autorise IT sur dbordement TIMER0
	GIE=1;			// autorise toutes les IT
	while(1); 
}

