// ITCOMP.c clignotement de la LED sur PB0 par interruption T=1.0s (TIMER1 et fonction compare)

// Dans cet exercice le rapport cyclique dpend de S2 (1/4 ou 3/4)
 
#include <p18f452.h>

#define t333h 0xA2		// les deux octets pour A2C2 soit 41666 (333ms = 41666*8uS)
#define t333l 0xC2
#define t167h 0x51		// les deux octets pour 5161 soit 20833 (167ms = 20833*8uS)
#define t167l 0x61

// sous programme d'interruption
#pragma interrupt vect18
void vect18(void)		
{

	if( PIR1bits.CCP1IF)				// l'IT provient d'une comparaison
			{						
						PORTBbits.RB0=!PORTBbits.RB0;	//bascule PB0
					   	if (PORTAbits.RA4 && PORTBbits.RB0)
					   		{
					   				CCPR1H=t333h;	// RB0=1 prochaine it dans 333mS 
									CCPR1L=t333l;
					   		}
					   	if (PORTAbits.RA4 && !PORTBbits.RB0)
					   		{
					   				CCPR1H=t167h;	// RB0=0 prochaine it dans 167mS 
									CCPR1L=t167l;
					   		}
					   	if (!PORTAbits.RA4 && PORTBbits.RB0)
					   		{
					   				CCPR1H=t167h;	// RB0=1 prochaine it dans 167mS 
									CCPR1L=t167l;
					   		}
					   	if (!PORTAbits.RA4 && !PORTBbits.RB0)
					   		{
					   				CCPR1H=t333h;	// RB0=0 prochaine it dans 333mS 
									CCPR1L=t333l;
					   		} 
					 	
			}
	 PIR1bits.CCP1IF=0;	//efface le drapeau d'IT
}			


#pragma code vecteur18=0x18
void vers_it18(void)
{
_asm goto vect18 _endasm
}
#pragma code

			
void main(void)
{	
// configure PORTB
	PORTBbits.RB0=0;		// RB0 en sortie
	TRISBbits.TRISB0=0;
	
// configure le TIMER1
	T1CONbits.RD16=0;	// TMR1 mode simple (pas de RW)
	T1CONbits.TMR1CS=0;	// compte les impulsions sur internal clock
	T1CONbits.T1CKPS1=1;	// prdiviseur =1/8 periode sortie = 8uS
	T1CONbits.T1CKPS0=1;	
	T1CONbits.T1SYNC=1;	// pas de synchronisation sur sleep/Reset	
	T1CONbits.TMR1ON=1;	// TMR1 Activ

// configure le mode comparaison sur le TIMER1 avec IT sur CCP1 toutes les 62500 priodes de 8us soit 125ms
	T3CONbits.T3CCP2=0;	// mode comparaison entre TMR1 et CCPR1
	CCP1CON=0x0B;	// Trigger special event sur comparaison (RAZ TIMER1 lors de l'galit)

	PIE1bits.CCP1IE=1;	// active IT sur mode comparaison CCP1

	RCONbits.IPEN=1;		// Interruption prioritaires actives
	INTCONbits.GIE=1;		// Toutes les IT dmasques autorises

	while(1);			// une boucle infinie, tout fonctionne en IT
}



