// mesure de priode sur CCP1 (RC2) (TIMER1 et fonction capture)
#include <p18f452.h>
#include <lcd_pd2.h>
#include <xlcd.h>
#include <stdlib.h>			// pour itoa

unsigned int duree=5555;	// reprsente le comptage entre 2 fronts
char maj=1;					// indique qu'une nouvelle mesure est prte
char chaine[6];				// pour itoa
float freq;

// sous programme d'interruption
#pragma interrupt itcomp
void itcomp(void) 
{
	if(PIR1bits.CCP1IF)				// l'IT provient d'une capture
			{						
			duree=CCPR1;  	// comptage entre les deux front
			maj=1;					// nouvelle mesure prete
			}
	PIR1bits.CCP1IF=0;				//efface le drapeau d'IT
}			
			
#pragma code interruption=0x8
void fontion (void)
{
_asm goto itcomp  _endasm
}
#pragma code


void main(void)
{	
// configure PORTC CCP1
	DDRCbits.RC2=1;	// RC2/CCP1 en entree

// configure le TIMER1
	T1CONbits.RD16=0;		// TMR1 mode simple (pas de RW)
	T1CONbits.TMR1CS=0;		// compte les impulsions sur internal clock
	T1CONbits.T1CKPS1=1;	// prdiviseur =1/8 periode sortie = 8uS
	T1CONbits.T1CKPS0=1;	
	T1CONbits.T1SYNC=1;		// pas de synchronisation sur sleep/Reset	
	T1CONbits.TMR1ON=1;		// TMR1 Activ

// configure le mode capture sur le TIMER1 avec IT sur CCP1 
	T3CONbits.T3CCP2=0;		// mode comparaison entre TMR1 et CCPR1
	CCP1CON=0x05;			// capture mode sur fronts montants
	
	PIE1bits.CCP1IE=1;		// active IT sur mode capture/comparaison CCP1
	
	RCONbits.IPEN=1;		// Interruption prioritaires actives
	INTCONbits.GIE=1;		// Toutes les IT dmasques autorises
	initLCDPD2();
	gotoxy(0,0);
	putrsXLCD("freq= ");
	while(1)
		{
		if (maj) {
					gotoxy(6,0);
					freq=1.0/((float)duree*8e-6);
					ftoa(freq,chaine,5,'f'); //  erreur possible ! itoa travaille sur un signed int
					putsXLCD(chaine);	// affiche duree
					putrsXLCD("    ");	// efface fin de ligne
					maj=0;
				}
		}
}

