#include <p18f452.h>
#include <stdlib.h>
#include "initxlcd.c"
#include "ftoa.c"

#define q 4.8828e-3	// quantum pour un CAN 10bits 0v-5v

rom const char eff[]="                ";
char chaine[30];
unsigned long i=0;
unsigned char e=0;
float res=0.0;

void effaceLCD(void)
{
	SetDDRamAddr(0);		
	putrsXLCD(eff);
	SetDDRamAddr(0x40);		
	putrsXLCD(eff);
}

unsigned int mesvolt(unsigned char canal)
{	
	ADCON0=ADCON0|(canal<<3);
	ADCON0bits.GO_DONE=1;		// SOC
	while(ADCON0bits.GO_DONE);	// attend EOC
	return (ADRES);
}

void main(void)
{	ADCON0=1;				// CAN on. CLOCK=FOSC/2. 
	ADCON1=0x80;			// justification  droite, toutes les entres AN actives, VREF+=VDD VREF-=VSS
	OpenXLCD(FOUR_BIT & LINES_5X7 );		// donnes afficheur sur 4 bits (RD0  RD4)
	while(1){
				for (e=0;e<8;e++)
				{	
					effaceLCD();
				    SetDDRamAddr(0);		
					btoa(e,chaine);	
					putsXLCD(chaine);
					putchar('=');
					res=(float)(mesvolt(e))*q;			// calcule la tension sur ANx
					ftoa(res,chaine,5,'f');		// convertit en chaine
					putsXLCD(chaine);
					for (i=0;i<0x1ffff;i++);		// petite tempo
				}
			}
}
