// Calendrier ( partir de sur RTC.C)
// mise  la date lors de la compilation
// Horloge temps rel (Real Time Clock) avec quatz 32KHz sur TIMER1 sur PICDEM2+
// CD Lyce Fourcade 13120 Gardanne 10/2002

// ATTENTION, RETIRER LE CAVALIER J6 pour utiliser S3

#define S2 PORTAbits.RA4 // bouton S2 du KIT PICDEM2+

#include <stdlib.h>
#include "initxlcd.c"

char jour=27,mois=9;
int an=2004;
char heures=0,minutes=0,secondes=0;
char chaine[5];
char drapeau;		
const rom char efface[]="    ";


void affiche(void)
{
            SetDDRamAddr(5);				
			if (heures<10) putchar ('0');
			putsXLCD(btoa(heures,chaine));
			putchar(':');
			if (minutes<10) putchar ('0');
			putsXLCD(btoa(minutes,chaine));
			putchar(':');
			if (secondes<10) putchar ('0');
			putsXLCD(btoa(secondes,chaine));
			putrsXLCD(efface);
			
            SetDDRamAddr(0x45);	
			if (jour<10) putchar ('0');
			putsXLCD(btoa(jour,chaine));
			putchar('/');
			if (mois<10) putchar ('0');
			putsXLCD(btoa(mois,chaine));
			putchar('/');
			putsXLCD(itoa(an,chaine));
			putrsXLCD(efface);			
}

void moissuiv(void)
{
 jour=1;
 if (++mois>12) mois=1;			
}


// sous programme d'interruption
#pragma interrupt ITTIMER1		// choix du niveau d'interruption (donc du vecteur)
void ITTIMER1()		
{
	if(PIR1bits.CCP1IF)			//vrifie un dbordement sur TMR1
		{
		 PIR1bits.CCP1IF=0;	//efface le drapeau d'IT
		 drapeau=1;  // signale que les secondes changent
		 if (++secondes>=60) 
					{secondes=0;
				     if (++minutes>=60) 
							{minutes=0;
							if(++heures>=24) 
									  {heures=0;
									  if(++jour>30) 
											{switch (mois)
												{
												case(2): moissuiv();
												case(4): moissuiv();
												case(6): moissuiv();
												case(9): moissuiv();
												case(11): moissuiv();
												}
												if(jour>31) moissuiv();
											}
		  					         }
							}
				     }
		}					  
	if (INTCONbits.INT0IF)			// vrifie que l'IT est INT0, origine PB0=0 (bouton S3)
			{
			INTCONbits.INT0IF=0;			//efface le drapeau d'IT
			if(++heures>=24) heures=0;	    //rgalge des heures en IT
			}
}

#pragma code vecteur_d_IT=0x08	// vecteur d'IT
void une_fonction(void)
{
_asm goto ITTIMER1 _endasm
}
#pragma code


void main(void)
{	
// configure IT sur PB0
	TRISBbits.TRISB0=1;	// PRB0 en entre
	INTCONbits.INT0IE=1;	// INT0 active 

// configure le TIMER1
	T1CONbits.RD16=0;	// TMR1 mode simple (pas de RW)
	T1CONbits.T1OSCEN=1;	// active l'oscillateur 32 KHz
	T1CONbits.TMR1CS=1;	// compte les impulsions sur TIOSC
	T1CONbits.T1CKPS1=0;	// prdiviseur =1/1
	T1CONbits.T1CKPS0=0;	
	T1CONbits.T1SYNC=1;	// pas de synchronisation sur sleep/Reset	
	T1CONbits.TMR1ON=1;	// TMR1 Activ

// configure le mode comparaison sur le TIMER1 avec IT sur CCP1 toutes les 32768 priodes 
	T3CONbits.T3CCP2=0;	// mode comparaison entre TMR1 et CCPR1
	CCP1CON=0x0B;	// Trigger special event sur comparaison (RAZ TIMER1 lors de l'galit)
	CCPR1H=0x80;	// galit aprs 32768 priodes 
	CCPR1L=0;
	PIE1bits.CCP1IE=1;	// active IT sur mode comparaison CCP1

	RCONbits.IPEN=1;		// Interruption prioritaires actives
	INTCONbits.GIE=1;		// Toutes les IT dmasques autorises

	OpenXLCD(FOUR_BIT & LINES_5X7 );
	
	while(1) {
			if (drapeau)	{	
							drapeau=0;
							affiche();
							}
			if (!S2)					// scrutation de RA4 pour rglage minutes
				{ 								// bouton S2
				if (++minutes>=60) minutes=0;
				while(!S2);				// anti-rebond
				}
		 }
}

