#include <p18f452.h>

//d'aprs C HiTECH
/* erasing a flash program memory row*/	
void FLASH_ERASE(rom unsigned char * addr) 
{
	TBLPTR=(unsigned int)addr;
	TBLPTRU=0;  
	EECON1|=0x94; EECON1&=0xBF; 
	STATUSbits.C=0; if(INTCONbits.GIE) STATUSbits.C=1; INTCONbits.GIE=0; 
	STATUSbits.DC=0; if(INTCONbits.PEIE) STATUSbits.DC=1; INTCONbits.PEIE=0; 
	EECON2=0x55;EECON2=0xAA;EECON1bits.WR=1; 
	Nop(); 
	if(STATUSbits.C) INTCONbits.GIE=1; 
	if(STATUSbits.DC) INTCONbits.PEIE=1; 
}

//criture en flash 
void flash_write(unsigned char * source_addr,unsigned char length,rom unsigned char * dest_addr)
{
	/* variable declaration */
	unsigned char BUFFER[64];
	unsigned char index;
	unsigned char offset;

	unsigned int i;
	i=(unsigned int)dest_addr;

	offset=(unsigned char)dest_addr;
	while(offset>64)
		offset-=64;
	dest_addr-=offset;
	
	while(length)
	{
		// fill the 64 byte data buffer either from ...
		for(index=0;index<64;index++)
		{
			if((index>=offset)&&(length))	// specifed data area or ...
			{
				BUFFER[index]=*(source_addr++);
				length--;
			}
			else				// otherwise from destination sector.
				BUFFER[index]=*(dest_addr+index);
		}

		FLASH_ERASE(dest_addr);
	
// now begin to copy the buffer to the destination area

		TBLPTRU=0;	// if 16 bit code pointers selected, TBLPTRU must be cleared manually

		TBLPTR=--i;	// load the destination address
		
		offset=0;
		for(index=0;index<64;index++)
		{
			
			TABLAT=BUFFER[index];	// copy the data buffer to the
			_asm TBLWTPREINC	_endasm // internal write buffer	
			
			if(++offset==8)	// after every 8th byte, the
			{			// the write buffer is written to flash.
				EECON1bits.EEPGD=1; EECON1bits.WREN=1;		// this is the required sequence
				STATUSbits.C=0;if(INTCONbits.GIE)STATUSbits.C=1; INTCONbits.GIE=0;
				EECON2=0x55;
				EECON2=0xAA;
				EECON1bits.WR=1;
				Nop();
				if (STATUSbits.C) INTCONbits.GIE=1;
				EECON1bits.WREN=0;
				offset=0;
			}
		}
		dest_addr+=65;
	}
}

/* Petit programme de test
void main(void)
{
unsigned char chaine[]="salut";
unsigned char *ramptr;
rom unsigned char *romptr;
#pragma romdata marom=0x1000
rom unsigned char chainerom[6];

flash_write(chaine,6,chainerom);
ramptr=(unsigned char *) 0x200;
romptr=(rom unsigned char *) 0x1000;
while (*ramptr++=*romptr++);

while(1);
}
*/
