// fprintf.c
// demo pour fontion fprintf sur C18, emission sur USART et afficheur LCD sur PD2+
#include <p18f452.h>
#include <stdio.h>  // pour fprintf
#include <xlcd.h>	// pour OpenXLCD et putcXLCD

// dirige user_putc vers l'afficheur LCD du PD2+
int _user_putc (char c)
{
	putcXLCD(c);
}

// main ecrit sur l'afficheur LCD du PICDEM2+ et sur l'USART (necessite un terminal sur PC)
void main(void)
{
	SPBRG = 25; 	           			/* configure la vitesse (BAUD) 9600 N 8 1*/
    TXSTA = 0x24; 	                  
    RCSTA = 0x90;			 			/* active l'USART*/
	OpenXLCD(FOUR_BIT & LINES_5X7 );	//initialise PIC pour LCD sur PD2
    SetDDRamAddr(0);					//ligne 0 de l'afficheur
	fprintf (_H_USART, "fprintf USART\n");  // vers USART
	fprintf (_H_USER, "fprintf USER\n" );	// vers LCD
	while(1);
}
	
