#ifndef __XLCD_H
#include <xlcd.h>	// fonctions de gestion du LCD
#endif
#include <delays.h>

// chaine d'espace pour effacer le LCD
rom const unsigned char vide[]="                ";

// positionne le curseur en x-y (0<x<15 et 0<y<1
void gotoxy(unsigned char x, unsigned char y)
{
if (y) SetDDRamAddr(0x40+x);
 else SetDDRamAddr(x);
}

// efface l'afficheur
void efface(void)
{
	gotoxy(0,0);	// positionne le curseur en x,y
	putrsXLCD((const rom unsigned char *)vide);
	gotoxy(0,1);
	putrsXLCD((const rom unsigned char *)vide);
}

void putchar(char data)
{
	WriteDataXLCD(data);
}

// dirige user_putc vers l'afficheur LCD du PD2+
int _user_putc (char c)
{
	putcXLCD(c);
}

// Temporisation ncessaires aux composants de la bibliothque XLCD
void DelayFor18TCY(void) 
{
Delay10TCYx(2);
}

void DelayPORXLCD(void)
{
Delay1KTCYx(15); //Delai de 15 ms
}

void DelayXLCD(void)
{
Delay1KTCYx(20); //Delai de 20 ms
}
