// CD 03/03
// Test des communications asynchrones sans IT 
// connecter un mulateur de terminal sur le pour srie de PICDEM2+
// Attention au cable PC (brochage RX/TX)
#include <p18f452.h>

rom char mess[]="\nLes communications sont ouvertes\nTapez une touche ...\n\n";

// indique qu'un caractre est dans RCREG de l'USART 
char data_recue(void)			// reception d'une interruption
{
	if (PIR1bits.RCIF)		/* char recu en reception*/
	{	
		PIR1bits.RCIF=0;	// efface drapeau
		return (1);			// indique qu'un nouveau caractre est dans RCREG
	}	
	else return (0);		// pas de nouveau caractre reu
}

// envoie un caractre sur USART
void putch(unsigned char c) 		//putch est dfini sur le port srie
{
	while(!TXSTAbits.TRMT);			// pas de transmission en cours ?
    TXREG=c;                           /* envoie un caractre */
    while(!PIR1bits.TXIF);
}

// envoie une chaine en ROM
void putchaine(rom char* chaine)
{
	while (*chaine) putch(*chaine++);
}

void main(void)
{
    SPBRG = 25; 	           			/* configure la vitesse (BAUD) 9600 N 8 1*/
    TXSTA = 0x24; 	                  
    RCSTA = 0x90;			 			/* active l'USART*/

    putchaine(mess);				// intro
    while(1)						// echo
	    {
			if (data_recue()) putch(RCREG);                                                   
    	}
}
