#include <delays.h>	// temporisation pour afficheur LCD
#include <xlcd.h>	// fonctions de gestion du LCD
#include <stdlib.h>	// pour itoa, btoa etc...
#include "ftoa.c"	// ftoa n'est pas inclue dans MCC18

#define putchar(a) WriteDataXLCD(a)  // putchar est standard C ANSI


char chaine[]="RAM";	// une chaine de caractre en RAM
unsigned char tampon[5];		// mmoire pour les chaine converties avec ITOA BTOA 
unsigned char tamponf[30];		// mmoire pour les chaine converties avec FTOA
float f;				// un rel  afficher

// Temporisation ncessaires aux composants de la bibliothque XLCD
void DelayFor18TCY(void) {
Delay10TCYx(2);
}
void DelayPORXLCD(void)
{
Delay1KTCYx(15); //Delai de 15 ms
}
void DelayXLCD(void)
{
Delay1KTCYx(20); //Delai de 20 ms
}

void main(void) //Programme principal
{
   OpenXLCD(FOUR_BIT & LINES_5X7 );
   SetDDRamAddr(0);	// positionne le curseur en x,y
   putsXLCD(chaine);		// crit un chaine mmorise en RAM
   SetDDRamAddr(0x40);	
   putrsXLCD("ROM");		// crit une chaine mmorise en ROM
   SetDDRamAddr(4);
   putsXLCD(itoa(1234,tampon));  // crit un integer (16 bits)
   SetDDRamAddr(0x44);
   putsXLCD(btoa(-12,tampon));	// crit un byte  (8 bits)
   SetDDRamAddr(0x48);
   putchar('c');		// crit un caractre (putchar est standard C ANSI)
   f=5000.0/3.0; 		// calcul d'un rel pour exemple d'affichage
   SetDDRamAddr(9);
   putsXLCD(ftoa(f,tamponf,2,'S'));	// affichage scientifique 1.67E3, 2 chiffres aprs la virgule
   SetDDRamAddr(0x4A);
   putsXLCD(ftoa(f,tamponf,2,'F'));	// affichage normal 1666.67
   while(1);
}

