/* gestion SCI en IT    C.Dupaty 01/2003
Chaque caractre reu est copier dans un buffer par une
routine d'interruption. */

#define SIZE	40	/* taille buffer */
#define TDRE	0x80	
#include <p18f452.h>

/*	Variables globales */
char buffer[SIZE];	/* buffer de reception */
char *ptlec;		/* pointeur de lecture */
char *ptecr;		/* pointeur d'criture */

/*	Character reception d'un caractre.
 *	boucle jusqu' rception.
 */
char getsci(void)
	{
	char c;				
	while (ptlec == ptecr);
	c = *ptlec++;			
	if (ptlec >= &buffer[SIZE])	ptlec = buffer;
	return (c);
	}

/*	emission d'un caractre
 */
void putsci(char c)
	{
	while(!TXSTAbits.TRMT);
    TXREG=c;                           /* envoie un caractre */
    while(!PIR1bits.TXIF);
	}

/* initialise les communications et interruptions*/
void initsci(void)
	{
	TRISCbits.TRISC7 = 1;  // RX - Set Recieve pin for tristate
	TRISCbits.TRISC6 = 0;  // TX - Set as Output

    SPBRG = 25; 	                  /* configure la vitesse (BAUD) 9600*/
    TXSTA = 0x24; 	                  
    RCSTA = 0x90;			 		/* active l'USART  CREN=1 et SPEN=1*/
    PIR1bits.TXIF=0;				// IT en emission dsactive
    PIE1bits.RCIE=1;				// IT en reception active

	INTCONbits.GIEH=1;                                 /*autorise les IT */
    INTCONbits.GIEL=1; 	
	}


/* retourne une chaine de caractre*/
char *getstsci(char *s, char finst)
	{
	char *r = s;
	char c;

	while ((c = getsci()) != finst)	*s++ = c;
		*s = 0;
	return r;
	}
/* envoie une chaine de caractre*/
int putstsci(char *s)
	{
	int n;

	for (n = 0; *s; n++, s++) putsci(*s);
//	putsci('\n');
	return 1;
	}


#pragma interrupt ISR
void ISR(void)				// reception d'une interruption
{char c;
	if(PIR1bits.RCIF)		/* detection IT USART en reception*/
	{
		c=RCREG;
		*ptecr++ = c;		
		if (ptecr >= &buffer[SIZE]) ptecr = buffer;
		PIR1bits.RCIF=0;
	}	
}

#pragma code vecteurITH=0x8
void une_fonction(void)
{
_asm goto ISR _endasm
}
#pragma code




void main(void)
{
char chaine[]="Bonjour les communications sont ouvertes";
	initsci();
	putstsci(chaine);
    while(1)
    {									// mettre une des 2 lignes ci dessous en commentaires
 //	putsci(getsci()+1);					// emmision / rception d'un caractre
 	putstsci(getstsci(chaine,'*'));		// emmision / rception d'une chaine
 	
    }
}
